diff -cNr ivtools-0.6.orig/src/Unidraw/catcmds.c ivtools-0.6/src/Unidraw/catcmds.c
*** ivtools-0.6.orig/src/Unidraw/catcmds.c	Fri Feb 28 08:41:43 1997
--- ivtools-0.6/src/Unidraw/catcmds.c	Wed Jan 28 20:32:13 1998
***************
*** 48,53 ****
--- 48,61 ----
  #include <stream.h>
  #include <string.h>
  
+ #ifdef JIV_EXTEND
+ static const char* tmpLabel;
+ 
+ #define getLabel(attr, default) \
+     (((tmpLabel = unidraw->GetCatalog()->GetAttribute(attr)) != NULL) ? \
+      tmpLabel : default)
+ #endif
+ 
  /*****************************************************************************/
  
  static void UpdateCompNameVars () {
***************
*** 85,91 ****
--- 93,103 ----
      ModifStatusVar* mv = (ModifStatusVar*) ed->GetState("ModifStatusVar");
  
      if (mv != nil && Writable(mv->GetComponent()) && mv->GetModifStatus()) {
+ #ifndef JIV_EXTEND
          ConfirmDialog dialog("Save changes?");
+ #else
+         ConfirmDialog dialog(getLabel("MEndConfirm", "Save changes?"));
+ #endif
  
          ed->InsertDialog(&dialog);
          char resp = dialog.Confirm();
***************
*** 216,224 ****
                  delete root;
  
              } else {
                  ConfirmDialog dialog(
!                     "Couldn't revert! (File nonexistent?)", "Save changes?"
                  );
                  ed->InsertDialog(&dialog);
                  char confirmation = dialog.Confirm();
                  ed->RemoveDialog(&dialog);
--- 228,244 ----
                  delete root;
  
              } else {
+ #ifndef JIV_EXTEND
+                 ConfirmDialog dialog(
+                     "Couldn't revert! (File nonexistent?)",
+ 		    "Save changes?"
+                 );
+ #else
                  ConfirmDialog dialog(
!                     "Couldn't revert! (File nonexistent?)",
! 		    getLabel("MEndConfirm", "Save changes?")
                  );
+ #endif
                  ed->InsertDialog(&dialog);
                  char confirmation = dialog.Confirm();
                  ed->RemoveDialog(&dialog);
***************
*** 281,287 ****
  	char buf[CHARBUFSIZE];
  	const char* domain = unidraw->GetCatalog()->GetAttribute("domain");
  	domain = (domain == nil) ? "component" : domain;
! 	sprintf(buf, "Select a %s to open:", domain);
  	style->attribute("caption", "");
  	style->attribute("subcaption", buf);
      } else {
--- 301,311 ----
  	char buf[CHARBUFSIZE];
  	const char* domain = unidraw->GetCatalog()->GetAttribute("domain");
  	domain = (domain == nil) ? "component" : domain;
! #ifndef JIV_EXTEND
!         sprintf(buf, "Select a %s to open:", domain);
! #else
!         sprintf(buf, getLabel("MOpen", "Select a %s to open:"), domain);
! #endif
  	style->attribute("caption", "");
  	style->attribute("subcaption", buf);
      } else {
***************
*** 368,374 ****
--- 392,403 ----
              char subtitle[CHARBUFSIZE];
              const char* domain = unidraw->GetCatalog()->GetAttribute("domain");
              domain = (domain == nil) ? "component" : domain;
+ #ifndef JIV_EXTEND
              sprintf(subtitle, "Save this %s as:", domain);
+ #else
+             sprintf(subtitle, getLabel("MSaveAs", "Save this %s as:"),
+ 		    domain);
+ #endif
  
  	    Style* s = new Style(Session::instance()->style());
  	    s->attribute("caption", title);
***************
*** 417,423 ****
--- 446,456 ----
      char buf[CHARBUFSIZE];
      const char* domain = unidraw->GetCatalog()->GetAttribute("domain");
      domain = (domain == nil) ? "component" : domain;
+ #ifndef JIV_EXTEND
      sprintf(buf, "Save this %s as:", domain);
+ #else
+     sprintf(buf, getLabel("MSaveAs", "Save this %s as:"), domain);
+ #endif
  
      boolean reset_caption = false;
      Style* style = new Style(Session::instance()->style());
diff -cNr ivtools-0.6.orig/src/Unidraw/dialogs.c ivtools-0.6/src/Unidraw/dialogs.c
*** ivtools-0.6.orig/src/Unidraw/dialogs.c	Wed Jan 21 10:05:55 1998
--- ivtools-0.6/src/Unidraw/dialogs.c	Wed Jan 28 20:32:13 1998
***************
*** 27,32 ****
--- 27,36 ----
  #include <Unidraw/dialogs.h>
  #include <Unidraw/globals.h>
  #include <Unidraw/iterator.h>
+ #ifdef JIV_EXTEND
+ #include <Unidraw/unidraw.h>
+ #include <Unidraw/catalog.h>
+ #endif
  
  #include <IV-2_6/InterViews/adjuster.h>
  #include <IV-2_6/InterViews/border.h>
***************
*** 48,53 ****
--- 52,65 ----
  #include <stdlib.h>
  #include <string.h>
  
+ #ifdef JIV_EXTEND
+ static const char* tmpLabel;
+ 
+ #define getLabel(attr, default) \
+     (((tmpLabel = unidraw->GetCatalog()->GetAttribute(attr)) != NULL) ? \
+      tmpLabel : default)
+ #endif
+ 
  /*****************************************************************************/
  
  static void ChangeMsg (const char* name, MarginFrame* frame) {
***************
*** 148,154 ****
              new VGlue(space),
              new HBox(
                  new HGlue,
!                 new PushButton("  OK  ", state, 1),
                  new HGlue
              )
          ), space, space/2, 0
--- 160,172 ----
              new VGlue(space),
              new HBox(
                  new HGlue,
!                 new PushButton(
! #ifndef JIV_EXTEND
! 			       "  OK  ",
! #else
! 			       getLabel("BOK", "  OK  "),
! #endif
! 			       state, 1),
                  new HGlue
              )
          ), space, space/2, 0
***************
*** 197,207 ****
              new VGlue(space),
              new HBox(
                  new HGlue,
!                 new PushButton("  Yes  ", state, 'y'),
                  new HGlue(space, 0),
!                 new PushButton("  No  ", state, 'n'),
                  new HGlue(space, 0), 
!                 new PushButton("Cancel", state, '\007'),
                  new HGlue
              )
          ), space, space/2, 0
--- 215,243 ----
              new VGlue(space),
              new HBox(
                  new HGlue,
!                 new PushButton(
! #ifndef JIV_EXTEND
! 			       "  Yes  ",
! #else
! 			       getLabel("BYes", "  Yes  "),
! #endif
! 			       state, 'y'),
                  new HGlue(space, 0),
!                 new PushButton(
! #ifndef JIV_EXTEND
! 			       "  No  ",
! #else
! 			       getLabel("BNo", "  No  "),
! #endif
! 			       state, 'n'),
                  new HGlue(space, 0), 
!                 new PushButton(
! #ifndef JIV_EXTEND
! 			       "Cancel",
! #else
! 			       getLabel("BCancel", "Cancel"),
! #endif
! 			       state, '\007'),
                  new HGlue
              )
          ), space, space/2, 0
***************
*** 301,307 ****
              new HBox(
                  new VGlue(space, 0),
                  new HGlue,
!                 new PushButton("Cancel", state, '\007'),
                  new HGlue(space, 0),
                  new PushButton(acptlbl, state, '\r')
              )
--- 337,349 ----
              new HBox(
                  new VGlue(space, 0),
                  new HGlue,
!                 new PushButton(
! #ifndef JIV_EXTEND
! 			       "Cancel",
! #else
! 			       getLabel("BCancel", "Cancel"),
! #endif
! 			       state, '\007'),
                  new HGlue(space, 0),
                  new PushButton(acptlbl, state, '\r')
              )
***************
*** 337,347 ****
--- 379,397 ----
      if (print_cmd == nil) {
          const char* printer_name = getenv("PRINTER");
  
+ #ifndef IV_FIX
          if (printer_name == nil) {
              printer_name = "<printer name>";
          }
  
          sprintf(buf, "lpr -P%s", printer_name);
+ #else
+         if (printer_name != nil) {
+ 	    sprintf(buf, "lpr -P%s", printer_name);
+         } else {
+ 	    sprintf(buf, "lpr");
+ 	}
+ #endif
          print_cmd = buf;
      }
      return print_cmd;
***************
*** 355,361 ****
--- 405,415 ----
      _to_printer = -1;
      _dest = new PrintBS(this, to_printer);
  
+ #ifndef JIV_EXTEND
      FileChooser::Init("", "Generate PostScript and");
+ #else
+     FileChooser::Init("", getLabel("MPrint1", "Generate PostScript and"));
+ #endif
      Insert(Interior());
  
      ToPrinter(to_printer);
***************
*** 416,430 ****
--- 470,497 ----
                  new HGlue(space, 0),
                  new VBox(
                      new VGlue(space/3, 0),
+ #ifndef JIV_EXTEND
                      new RadioButton(
                          "send to printer via a command, or ", _dest, true
                      ),
                      new VGlue(space/3, 0),
+ #else
+                     new RadioButton(
+                         getLabel("MPrint2",
+ 				 "send to printer via a command, or "),
+ 			_dest, true
+                     ),
+ #endif
  #ifdef __DECCXX
  		    /* is passing an const unsigned 0 ambiguous here? */
                      new RadioButton("save in file:", _dest, int(false))
  #else
+ #ifndef JIV_EXTEND
                      new RadioButton("save in file:", _dest, false)
+ #else
+                     new RadioButton(getLabel("MPrint3", "save in file:"),
+ 				    _dest, false)
+ #endif
  #endif
                  )
              ),
***************
*** 437,445 ****
              ),
              new HBox(
                  new HGlue,
!                 new PushButton("Cancel", state, '\007'),
!                 new HGlue(space, 0),
!                 new PushButton("  OK  ", state, '\r')
              )
          ), space, space/2, 0
      );
--- 504,524 ----
              ),
              new HBox(
                  new HGlue,
!                 new PushButton(
! #ifndef JIV_EXTEND
! 			       "Cancel",
! #else
! 			       getLabel("BCancel", "Cancel"),
! #endif
! 			       state, '\007'),
! 		new HGlue(space, 0),
!                 new PushButton(
! #ifndef JIV_EXTEND
! 			       "  OK  ",
! #else
! 			       getLabel("BOK", "  OK  "),
! #endif
! 			       state, '\r')
              )
          ), space, space/2, 0
      );
***************
*** 448,454 ****
  /*****************************************************************************/
  
  GridDialog::GridDialog () : BasicDialog(
!     new ButtonState, "", "Enter X and Y grid spacing:"
  ) {
      _medit = new MatchEditor(state, "9999999999999999999");
      _medit->Message("");
--- 527,538 ----
  /*****************************************************************************/
  
  GridDialog::GridDialog () : BasicDialog(
!     new ButtonState, "",
! #ifndef JIV_EXTEND
!     "Enter X and Y grid spacing:"
! #else
!     getLabel("MGridSpacing", "Enter X and Y grid spacing:")
! #endif
  ) {
      _medit = new MatchEditor(state, "9999999999999999999");
      _medit->Message("");
***************
*** 518,526 ****
              new VGlue(space),
              new HBox(
                  new HGlue,
!                 new PushButton("Cancel", state, '\007'),
  		new HGlue(space, 0),
!                 new PushButton("  OK  ", state, '\r')
              )
          ), space, space/2, 0
      );
--- 602,622 ----
              new VGlue(space),
              new HBox(
                  new HGlue,
!                 new PushButton(
! #ifndef JIV_EXTEND
! 			       "Cancel",
! #else
! 			       getLabel("BCancel", "Cancel"),
! #endif
! 			       state, '\007'),
  		new HGlue(space, 0),
!                 new PushButton(
! #ifndef JIV_EXTEND
! 			       "  OK  ",
! #else
! 			       getLabel("BOK", "  OK  "),
! #endif
! 			       state, '\r')
              )
          ), space, space/2, 0
      );
diff -cNr ivtools-0.6.orig/src/Unidraw/import.c ivtools-0.6/src/Unidraw/import.c
*** ivtools-0.6.orig/src/Unidraw/import.c	Sat Dec  6 09:17:10 1997
--- ivtools-0.6/src/Unidraw/import.c	Wed Jan 28 20:32:13 1998
***************
*** 57,62 ****
--- 57,70 ----
  #include <stdio.h>
  #include <string.h>
  
+ #ifdef JIV_EXTEND
+ static const char* tmpLabel;
+ 
+ #define getLabel(attr, default) \
+     (((tmpLabel = unidraw->GetCatalog()->GetAttribute(attr)) != NULL) ? \
+      tmpLabel : default)
+ #endif
+ 
  /*****************************************************************************/
  
  static int hexmap[] = {
***************
*** 236,242 ****
--- 244,255 ----
      boolean reset_caption = false;
      if (chooser_ == nil) {
  	style = new Style(Session::instance()->style());
+ #ifndef JIV_EXTEND
  	style->attribute("subcaption", "Import graphic from file:");
+ #else
+ 	style->attribute("subcaption",
+ 			 getLabel("MImport", "Import graphic from file:"));
+ #endif
  	style->attribute("open", "Import");
  	chooser_ = DialogKit::instance()->file_chooser(".", style);
  	Resource::ref(chooser_);
diff -cNr ivtools-0.6.orig/src/Unidraw/manips.c ivtools-0.6/src/Unidraw/manips.c
*** ivtools-0.6.orig/src/Unidraw/manips.c	Fri Feb 28 08:41:46 1997
--- ivtools-0.6/src/Unidraw/manips.c	Wed Jan 28 20:32:14 1998
***************
*** 43,48 ****
--- 43,55 ----
  
  #include <IV-2_6/_enter.h>
  
+ #ifdef JIV
+ #include <InterViews/canvas.h>
+ #include <InterViews/kinput.h>
+ #undef Coord
+ #define Coord _lib_iv2_6(Coord)
+ #endif /* JIV */
+ 
  #include <ctype.h>
  #include <math.h>
  #include <stdlib.h>
***************
*** 64,71 ****
  inline boolean ManipList::manipulating () { return _manipulating; }
  inline void ManipList::manipulating (boolean m) { _manipulating = m; }
  
! /****************************************************************************/
  
  ManipGroup::ManipGroup (Viewer* v, Tool* t) {
      _kids = new ManipList;
      _viewer = v;
--- 71,110 ----
  inline boolean ManipList::manipulating () { return _manipulating; }
  inline void ManipList::manipulating (boolean m) { _manipulating = m; }
  
! #ifdef JIV		/* 12 Jan 1992 eto@ai.cs.fujitsu.co.jp */
! #include <InterViews/clthandler.h>
! class KinputHandler : public ClientMessageHandler {
!   public:
!     KinputHandler(Kinput*, TextManip*);
!     ~KinputHandler(){;};
! 
!     boolean event(Event&);
!     boolean handle_p(const Event&);
!   private:
!     Kinput* kinput;
!     TextManip* textmanip;
! };
! 
! KinputHandler::KinputHandler(Kinput* k, TextManip* t) {
!     kinput = k;
!     textmanip = t;
! }
! 
! boolean KinputHandler::handle_p(const Event& ev) {
!     return kinput->IsKinputEvent(ev);
! }
! 
! boolean KinputHandler::event(Event& ev) {
!     if (kinput->Handle(ev)) {
! 	/* Hundle converted string */
! 	const char* convString;
! 	convString = kinput->GetConvertedString();
! 	textmanip->InsertText(convString, strlen(convString));
!     }
! }
! #endif /* JIV */
  
+ /****************************************************************************/
  ManipGroup::ManipGroup (Viewer* v, Tool* t) {
      _kids = new ManipList;
      _viewer = v;
***************
*** 487,492 ****
--- 526,535 ----
      _multiline = multiline;
      _tool = t;
      _dot = _mark = 0;
+ #ifdef JIV
+     kinput = nil;
+     khandler = nil;
+ #endif /* JIV */
      InitTextDisplay(sample, samplen);
  }
  
***************
*** 509,514 ****
--- 552,564 ----
  TextManip::~TextManip () { 
      delete _text;
      delete _display;
+ #ifdef JIV
+     if (kinput != nil) {
+ 	delete kinput;
+ 	GetViewer()->ResetClientMessageHandler(khandler);
+ 	delete khandler;
+     }
+ #endif JIV
      Unref(_painter);
  }
  
***************
*** 609,614 ****
--- 659,670 ----
  
      } else if (e.eventType == UpEvent) {
          _selecting = false;
+ #ifdef JIV			/* patch by eto@ai.cs.fujitsu.co.jp */
+     } else if (e.eventType == ClientEvent) {
+ 	khandler->event(e);
+     } else if (e.eventType == PropertyEvent) {
+ 	khandler->event(e);
+ #endif /* JIV */
      }
      return manipulating;
  }
***************
*** 643,649 ****
--- 699,711 ----
          case '\177':  DeleteCharacter(-1); break;
          case '\011':  InsertCharacter('\t'); break;
          case '\015':  if (_multiline) InsertCharacter('\n'); break;
+ #ifdef JIV
+         case '\012':  if (_multiline) InsertCharacter('\n'); break;
+ #endif /* JIV */
          case '\033':  manipulating = false; break;
+ #ifdef JIV
+         case '\034':  BeginConversion(); break;		/* ^\ */
+ #endif /* JIV */
          default:
              if (!iscntrl(c & 0x7f)) {
                  InsertCharacter(c);
***************
*** 683,693 ****
--- 745,760 ----
          }
      }
      Select(_dot + count);
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::DeleteText (int count) {
      int d = _dot;
      int c = count;
+ #ifndef JIV
      while (c > 0) {
          d = _text->NextCharacter(d);
          --c;
***************
*** 696,701 ****
--- 763,789 ----
          _dot = _text->PreviousCharacter(_dot);
          ++c;
      }
+ #else /* JIV */
+     if (c > 0) {
+ 	while (c > 0) {
+ 	    if ((unsigned char)(*(_text->Text(d))) >= 0xa1) {
+ 		d = _text->NextCharacter(d);
+ 		--c;
+ 	    }
+ 	    d = _text->NextCharacter(d);
+ 	    --c;
+ 	}
+     } else {
+ 	while (c < 0) {
+ 	    _dot = _text->PreviousCharacter(_dot);
+ 	    ++c;
+ 	    if ((unsigned char)(*(_text->Text(_dot))) >= 0xa1) {
+ 		_dot = _text->PreviousCharacter(_dot);
+ 		++c;
+ 	    }
+ 	}
+     }
+ #endif /* JIV */
      count = d - _dot;
      int sline = _text->LineNumber(_dot);
      int fline = _text->LineNumber(d);
***************
*** 710,734 ****
--- 798,842 ----
          _display->ReplaceText(sline, _text->Text(bol, eol), eol-bol);
      }
      Select(_dot);
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::DeleteLine () {
      Select(_text->BeginningOfLine(_mark), _text->BeginningOfNextLine(_mark));
      DeleteSelection();
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::DeleteSelection () {
      if (_mark != _dot) {
          DeleteText(_mark - _dot);
      }
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::BeginningOfSelection () {
      Select(min(_mark, _dot));
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::EndOfSelection () {
      Select(max(_mark, _dot));
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::BeginningOfWord () {
***************
*** 737,742 ****
--- 845,854 ----
      } else {
          Select(_text->BeginningOfWord(_dot));
      }
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::EndOfWord () {
***************
*** 745,750 ****
--- 857,866 ----
      } else {
          Select(_text->EndOfWord(_dot));
      }
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::BeginningOfLine () {
***************
*** 753,758 ****
--- 869,878 ----
      } else {
          Select(_text->BeginningOfLine(_dot));
      }
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::EndOfLine () {
***************
*** 761,774 ****
--- 881,906 ----
      } else {
          Select(_text->EndOfLine(_dot));
      }
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::BeginningOfText () {
      Select(_text->BeginningOfText());
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::EndOfText () {
      Select(_text->EndOfText());
+ 
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::ForwardCharacter (int count) {
***************
*** 777,787 ****
--- 909,928 ----
      } else {
          int d = _dot;
          while (count > 0) {
+ #ifdef JIV
+ 	    if ((unsigned char)(*(_text->Text(d))) >= 0xa1) {
+ 		d = _text->NextCharacter(d);
+ 		--count;
+ 	    }
+ #endif /* JIV */
              d = _text->NextCharacter(d);
              --count;
          }
          Select(d);
      }
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::BackwardCharacter (int count) {
***************
*** 792,800 ****
--- 933,950 ----
          while (count > 0) {
              d = _text->PreviousCharacter(d);
              --count;
+ #ifdef JIV
+ 	    if ((unsigned char)(*(_text->Text(d))) >= 0xa1) {
+ 		d = _text->PreviousCharacter(d);
+ 		--count;
+ 	    }
+ #endif /* JIV */
          }
          Select(d);
      }
+ #ifdef JIV
+     SetConversionSpot();
+ #endif /* JIV */
  }
  
  void TextManip::ForwardLine (int count) {
***************
*** 808,813 ****
--- 958,966 ----
          }
          Select(d);
      }
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::BackwardLine (int count) {
***************
*** 821,826 ****
--- 974,982 ----
          }
          Select(d);
      }
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::ForwardWord (int count) {
***************
*** 834,839 ****
--- 990,998 ----
          }
          Select(d);
      }
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
  }
  
  void TextManip::BackwardWord (int count) {
***************
*** 847,853 ****
--- 1006,1040 ----
          }
          Select(d);
      }
+ #ifdef JIV
+     SetConversionSpot();
+ #endif	/* JIV */
+ }
+ 
+ #ifdef JIV
+ void TextManip::BeginConversion () {
+     if (kinput == nil) {
+ 	kinput = new Kinput(GetViewer()->GetCanvas()->window());
+ 	khandler = new KinputHandler(kinput, this);
+ 	GetViewer()->SetClientMessageHandler(khandler);
+     }
+ 
+     if (kinput) {
+ 	int spotx, spoty;
+ 
+ 	_display->CaretPoint(spotx, spoty);
+ 	kinput->BeginConversion(spotx, spoty);
+     }
+ }
+ 
+ void TextManip::SetConversionSpot () {
+     if (kinput && kinput->IsActive()) {
+ 	int spotx, spoty;
+ 	_display->CaretPoint(spotx, spoty);
+ 	kinput->SetConversionSpot(spotx, spoty);
+     }
  }
+ #endif	/* JIV */
  
  void TextManip::Select (int d) {
      Select(d, d);
***************
*** 947,952 ****
--- 1134,1145 ----
      int l = _text->LineIndex(line);
      int i = 0;
      while (i < index) {
+ #ifdef JIV
+ 	if ((unsigned char)(*(_text->Text(l))) >= 0xa1) {
+ 	    l = _text->NextCharacter(l);
+ 	    i++;
+ 	}
+ #endif /* JIV */
          l = _text->NextCharacter(l);
          i += 1;
      }
